\section{Implementation}
\label{sec:implementation}

The problem presented in \autoref{sec:problem} has been implemented in AMPL
following the mathematical model described in \autoref{sec:mathematical-model}.
One can find the implementation code in \nameref{subsec:mod},
\nameref{subsec:dat} and \nameref{subsec:run}. Additionally one can find the
AMPL files in a
\href{https://gitlab.com/jemaro/wut/optimization-techniques/lp-9-bicycle-company-plan}{code
repository}.

\clearpage
\subsection{P1\_9.mod}
\label{subsec:mod}
\lstinputlisting{P1_9.mod}

\clearpage
\subsection{P1\_9.dat}
\label{subsec:dat}
\lstinputlisting{P1_9.dat}

\subsection{P1\_9.run}
\label{subsec:run}
\lstinputlisting{P1_9.run}

\clearpage
\section{Results}
\label{sec:results}

The AMPL implementation described in \autoref{sec:implementation} has been used
to find the solution to the optimization problem. \autoref{lst:results} shows
the AMPL console output of the solution.

\begin{lstlisting}[label={lst:results},caption={AMPL console output of the solution}]
ampl: include P1_9.run;
CPLEX 20.1.0.0: optimal solution; objective 11247
12 dual simplex iterations (0 in phase I)
x [*,*]
:  normal overtime    :=
1     28       0
2     15       0
3     15       0
4     28       0
5     30       0
6     30      10
7     30      15
8     30      15
9     26       0
10    14       0
11    25       0
12    30       0
;

\end{lstlisting}
\begin{minipage}{0.45\textwidth}
\centering
\begin{lstlisting}[label={lst:storage},caption={AMPL output of the monthly stored units}]
z [*] :=
 1  0
 2  0
 3  0
 4  3
 5  0
 6  0
 7  0
 8  0
 9  0
10  0
11  0
12  0
;

\end{lstlisting}
\end{minipage}\hfill
\begin{minipage}{.45\textwidth}
\centering
\begin{lstlisting}[label={lst:balance},caption={AMPL output of the monthly balance}]
b [*] :=
 1  -2
 2   0
 3   0
 4   3
 5  -3
 6   0
 7   0
 8   0
 9   0
10   0
11   0
12   0
;
\end{lstlisting}
\end{minipage}%

One can see that the optimizer reaches as solution that it is worth to produce
more bicycles on the month $4$, storing them to sell them on month $5$ in order
to do not make use of overtime production in that month. 

This can easily be observed in the displayed variable $b_m$ on
\autoref{lst:balance} where the value for month $4$ ($b_4$) is $3$, which means
$3$ thousand produced bicycles bikes that are not sold that month and they are
therefore stored. Which can also be spotted in the displayed variable $z_m$ on
\autoref{lst:storage}. The value of $b_5$ is $-3$, which means that there are
$3$ thousand bicycles sold that were not produced that month, they were
obtained from the storage.

\subsection{Conclusions}

The solution previously described is reasonable as the extra unitary price of
overtime production is greater than the unitary storage cost. 

\begin{equation}
    Cx_{overtime} - Cx_{normal} > Cz
    \label{eqn:storage-worth}
\end{equation}

A better solution has not been spotted and therefore we believe that this is
the optimal solution and that the mathematical model could be used in more
complex scenarios.

Finally, we can conclude that our problem has the \textbf{integrality}
property, because even if the solution has been computed in a continuous
domain, it is discrete.